@class CHMention;
@class CHMessage;
@class CHSearchResult;
@class CHSpace;
@class CHTeam;
@class CHMembership;
@class CHMessageText;
@class CHReadStatus;
@class CHCallMembership;
@class CHSpaceMeetingInfo;
@class CHPerson;
@class CHTeamMembership;
@class CHMembershipReadStatus;
@class CHLocalFile;
@class CHWebhook;
@class CHResource;
@class CHCall;
@class CHMeetingInfo;

enum CHConversationSortType: NSUInteger;
enum CHConversationType: NSUInteger;
enum CHMessageResult: NSUInteger;
enum CHTelemetry: NSUInteger;
enum CHUCBrowserLoginSSONavResult: NSUInteger;
enum CHCallAssociationType: NSUInteger;
enum CHTeamCreateResult: NSUInteger;
enum CHTeamGetResult: NSUInteger;
enum CHTeamArchiveResult: NSUInteger;
enum CHTeamUpdateResult: NSUInteger;
enum CHMarkMessageReadResult: NSUInteger;
enum CHGetMessageResult: NSUInteger;
enum CHDeleteMessageResult: NSUInteger;
enum CHPersonGetResult: NSUInteger;
enum CHGetMembershipByIdResult: NSUInteger;
enum CHCreateSpaceMembershipResult: NSUInteger;
enum CHMembershipUpdateResult: NSUInteger;
enum CHListMessagesResult: NSUInteger;
enum CHMembershipDeleteResult: NSUInteger;
enum CHListTeamMembershipResult: NSUInteger;
enum CHCreateTeamMembershipResult: NSUInteger;
enum CHGetTeamMembershipResult: NSUInteger;
enum CHUpdateTeamMembershipResult: NSUInteger;
enum CHDeleteTeamMembershipResult: NSUInteger;
enum CHListPersonsResult: NSUInteger;
enum CHPersonCreateResult: NSUInteger;
enum CHPersonUpdateResult: NSUInteger;
enum CHPersonDeleteResult: NSUInteger;
enum CHListMembershipResult: NSUInteger;
enum CHListMembershipsReadStatusResult: NSUInteger;
enum CHUpdateSpaceTitleResult: NSUInteger;
enum CHDeleteSpaceResult: NSUInteger;
enum CHUCLoginServerConnectionStatus: NSUInteger;
enum CHPhoneServiceRegistrationFailureReason: NSUInteger;
enum CHListWebhooksResult: NSUInteger;
enum CHCreateWebhookResult: NSUInteger;
enum CHGetWebhookByIdResult: NSUInteger;
enum CHUpdateWebhookByIdResult: NSUInteger;
enum CHDeleteWebhookByIdResult: NSUInteger;
enum CHResourceType: NSUInteger;
enum CHNotificationCallType: NSUInteger;
enum CHVideoRenderMode: NSUInteger;

typedef void (^SingleBoolCompletionFuncCallback)(BOOL success);
typedef void (^SingleOptionalStringCompletionFuncCallback)(NSString* _Nullable result);
typedef void (^VoidCompletionFuncCallback)();
typedef void (^SearchResultCompletionFuncCallback)(NSArray<CHSearchResult *> * _Nonnull searchResults);
typedef void (^TeamCreateResultCompletionFuncCallback)(enum CHTeamCreateResult result, CHTeam * _Nullable team);
typedef void (^TeamGetResultCompletionFuncCallback)(enum CHTeamGetResult result, CHTeam * _Nullable team);
typedef void (^TeamArchiveResultCompletionFuncCallback)(enum CHTeamArchiveResult result);
typedef void (^TeamUpdateResultCompletionFuncCallback)(enum CHTeamUpdateResult result, CHTeam * _Nullable team);
typedef void (^MarkMessageResultCompletionFuncCallback)(CHMarkMessageReadResult result);
typedef void (^SingleMessageCompletionFuncCallback)(CHMessage * _Nullable message, CHGetMessageResult result);
typedef void (^MessageDeleteResultCompletionFuncCallback)(CHDeleteMessageResult result);
typedef void (^MessagePostCompletionFuncCallback)(CHMessage * _Nullable message, CHMessageResult result);
typedef void (^MessageEventCompletionCallback)(enum CHMessageEvent messageEvent, CHMessage* _Nonnull message);
typedef void (^MessageEventWithPayloadCompletionCallback)(enum CHMessageEvent messageEvent, CHMessage* _Nonnull message, NSString* _Nullable actorId);
typedef void (^PersonGetResultCompletionFuncCallback)(enum CHPersonGetResult result, CHPerson * _Nullable person);
typedef void (^GetMembershipByMembershipIdCompletionFuncCallback)(CHMembership * _Nullable membership, CHGetMembershipByIdResult result);
typedef void (^CreateMembershipCompletionFuncCallback)(CHCreateSpaceMembershipResult result, CHMembership * _Nullable membership);
typedef void (^ListPersonsCompletionFuncCallback)(NSArray<CHPerson *> * _Nullable persons, CHListPersonsResult result);
typedef void (^CreatePersonCompletionFuncCallback)(CHPersonCreateResult result, CHPerson * _Nullable person);
typedef void (^UpdatePersonCompletionFuncCallback)(CHPersonUpdateResult result, CHPerson * _Nullable person);
typedef void (^DeletePersonCompletionFuncCallback)(enum CHPersonDeleteResult result);

typedef void (^MembershipUpdateResultCompletionFuncCallback)(enum CHMembershipUpdateResult result, CHMembership * _Nullable membership);
typedef void (^ListMessagesCompletionFuncCallback)(NSArray<CHMessage *> * _Nullable, CHListMessagesResult result);
typedef void (^MembershipDeleteResultCompletionFuncCallback)(CHMembershipDeleteResult result);
typedef void (^ListTeamMembershipCompletionFuncCallback)(enum CHListTeamMembershipResult result, NSArray<CHTeamMembership *> * _Nullable);
typedef void (^CreateTeamMembershipCompletionFuncCallback)(CHCreateTeamMembershipResult result, CHTeamMembership * _Nullable membership);
typedef void (^GetTeamMembershipCompletionFuncCallback)(enum CHGetTeamMembershipResult result, CHTeamMembership * _Nullable membership);
typedef void (^UpdateTeamMembershipCompletionFuncCallback)(enum CHUpdateTeamMembershipResult result, CHTeamMembership * _Nullable membership);
typedef void (^DeleteTeamMembershipCompletionFuncCallback)(enum CHDeleteTeamMembershipResult result);
typedef void (^ListMembershipsCompletionFuncCallback)(CHListMembershipResult result, NSArray<CHMembership *> * _Nullable);
typedef void (^ListMembershipsReadStatusCompletionFuncCallback)(enum CHListMembershipsReadStatusResult result, NSArray<CHMembershipReadStatus *> * _Nullable memberships);
typedef void (^MembershipEventCompletionCallback)(enum CHMembershipEvent membershipEvent, CHMembership* _Nonnull membership, NSString* _Nullable messageLastSeenId);
typedef void (^MembershipEventWithPayloadCompletionCallback)(enum CHMembershipEvent membershipEvent, CHMembership* _Nonnull membership, NSString* _Nullable messageLastSeenId, NSString* _Nullable actorId);
typedef void (^UpdateSpaceTitleResultCompletionFuncCallback)(CHUpdateSpaceTitleResult result, CHSpace * _Nullable space);
typedef void (^ListSpacesCompletionFuncCallback)(NSArray<CHSpace *>* _Nullable spaces);
typedef void (^SingleSpaceCompletionFuncCallback)(CHSpace* _Nullable space);
typedef void (^DeleteSpaceCompletionFuncCallback)(CHDeleteSpaceResult result);
typedef void (^SingleSpaceReadStatucCompletionFuncCallback)(CHSpaceReadStatus* _Nullable readStatus);
typedef void (^ListSpaceReadStatucCompletionFuncCallback)(NSArray<CHSpaceReadStatus *>* _Nullable readStatusList);
typedef void (^SpaceEventCompletionCallback)(enum CHSpaceEvent spaceEvent, CHSpace* _Nonnull space);
typedef void (^SpaceEventWithPayloadCompletionCallback)(enum CHSpaceEvent spaceEvent, CHSpace* _Nonnull space, NSString* _Nullable actorId);
typedef void (^MessageDownloadFileCompletionFuncCallback)(NSString* _Nonnull fileUrl);
typedef void (^MessageThumbnailResultCompletionFuncCallback)(NSData* _Nullable image);
typedef void (^ListWebhooksCompletionFuncCallback)(enum CHListWebhooksResult result, NSArray<CHWebhook *> * _Nullable);
typedef void (^CreateWebhookCompletionFuncCallback)(enum CHCreateWebhookResult result, CHWebhook * _Nullable webhook);
typedef void (^GetWebhookCompletionFuncCallback)(enum CHGetWebhookByIdResult result, CHWebhook * _Nullable webhook);
typedef void (^UpdateWebhookCompletionFuncCallback)(enum CHUpdateWebhookByIdResult result, CHWebhook * _Nullable webhook);
typedef void (^DeleteWebhookCompletionFuncCallback)(enum CHDeleteWebhookByIdResult result);
typedef void (^MessageDownloadFileProgressCompletionFuncCallback)(double bytes);
typedef void (^GetEncodedCompletionFuncCallback)(NSString* _Nonnull encoded, CHSpaceApiErrorInfo * _Nonnull error, bool alreadyEncoded);
typedef void (^CallScheduleChangedCompletionCallback)(CHCall * _Nullable call);
typedef void (^CallStartedCompletionCallback)(bool success, CHCall * _Nullable call);
typedef void (^DeviceChangedCompletionCallback)(CHCall * _Nullable call);
typedef void (^IncomingCompletionCallback)(CHCall * _Nullable call);
typedef void (^CallFailedCompletionCallback)(CHCall * _Nullable call);
typedef void (^CallRingingChangedCompletionCallback)(CHCall * _Nullable call);
typedef void (^CallConnectedCompletionCallback)(CHCall * _Nullable call);
typedef void (^CallDisconnectedCompletionCallback)(CHCall * _Nullable call);
typedef void (^CallTerminatedCompletionCallback)(CHCall * _Nullable call);
typedef void (^CallInfoChangedCompletionCallback)(CHCall * _Nullable call);
typedef void (^ListSpacesActiveCallsCompletionCallback)(NSArray<CHSpace *>* _Nullable spaces);
@protocol AppleSparkClientProvider;

//forward declare the protocol
@protocol OmniusServiceBridgeProtocol;

@protocol OmniusServiceBridgeDelegate
- (void)omniusServiceBridge:(id<OmniusServiceBridgeProtocol> _Nonnull)omniusServiceBridge showUCSSOLoginView:(NSString * _Nonnull)ssoUrl;
- (void)omniusServiceBridgeShowUCNonSSOLoginView:(id<OmniusServiceBridgeProtocol> _Nonnull) omniusServiceBridge;
- (void)omniusServiceBridgeOnUCLoggedIn:(id<OmniusServiceBridgeProtocol> _Nonnull) omniusServiceBridge;
- (void)omniusServiceBridgeOnUCLoggedOut:(id<OmniusServiceBridgeProtocol> _Nonnull) omniusServiceBridge;
- (void)omniusServiceBridgeOnUCLoginFailed:(id<OmniusServiceBridgeProtocol> _Nonnull) omniusServiceBridge;
- (void)omniusServiceBridge:(id<OmniusServiceBridgeProtocol> _Nonnull)omniusServiceBridge onUCServerConnectionStateChanged:(CHUCLoginServerConnectionStatus)status failureReason:(CHPhoneServiceRegistrationFailureReason)failureReason;
@end

@protocol OmniusServiceBridgeProtocol

@property(nonatomic, weak) id<OmniusServiceBridgeDelegate> _Nullable delegate;

- (instancetype _Nonnull)initWithSparkClientProvider:(id<AppleSparkClientProvider>_Nonnull)sparkClientProvider;
- (NSString * _Nullable)getAuthorizationUrl:(NSString * _Nonnull)email NS_SWIFT_NAME(getAuthorizationUrl(email:));
-(void)signOut:(VoidCompletionFuncCallback _Nonnull ) callback NS_SWIFT_NAME(signOut(callback:));
- (bool)isLoggedIn;
-(void)attemptToLoginWithCachedUser:(SingleBoolCompletionFuncCallback _Nonnull ) callback NS_SWIFT_NAME(attemptToLoginWithCachedUser(callback:));
-(void)loginWithAuthCode:(nonnull NSString*) authCode emailId:(nonnull NSString*) emailId callback:(SingleBoolCompletionFuncCallback _Nonnull ) callback
    NS_SWIFT_NAME(loginWithAuthCode(authCode:emailId:callback:));
- (void)loginWithJWT:(NSString * _Nonnull)jwt callback:(SingleBoolCompletionFuncCallback _Nonnull)callback
NS_SWIFT_NAME(loginWithJWT(authCode:callback:));
- (void)getAccessToken:(SingleOptionalStringCompletionFuncCallback _Nonnull ) callback NS_SWIFT_NAME(getAccessToken(callback:));
- (void)refreshAccessToken:(SingleOptionalStringCompletionFuncCallback _Nonnull ) callback NS_SWIFT_NAME(refreshAccessToken(callback:));
- (void)getJwtToken:(SingleOptionalStringCompletionFuncCallback _Nonnull ) callback NS_SWIFT_NAME(getJwtToken(callback:));
- (void)addLoginTelemetry:(enum CHTelemetry)loginEvent startTime:(NSDate * _Nonnull)startTime endTime:(NSDate * _Nonnull)endTime NS_SWIFT_NAME(addLoginTelemetry(loginEvent:startTime:endTime:));
- (void)setUCDomainServerUrl:(NSString * _Nonnull)ucDomain serverUrl:(NSString * _Nonnull)serverUrl NS_SWIFT_NAME(setUCDomainServerUrl(ucDomain:serverUrl:));
- (void)setCUCMCredential:(NSString * _Nonnull)username password:(NSString * _Nonnull)password NS_SWIFT_NAME(setCUCMCredential(username:password:));
- (void)processSSOBrowserNavigationResult:(enum CHUCBrowserLoginSSONavResult)result currentUrl:(NSString * _Nonnull)currentUrl document:(NSString * _Nonnull)document NS_SWIFT_NAME(processSSOBrowserNavigationResult(result:currentUrl:document:));
- (void)ucCancelSSOLogin;
- (bool)isUCLoggedIn;
- (CHUCLoginServerConnectionStatus)getUCServerConnectionStatus;
- (void)getSearchResult:(NSString * _Nonnull)searchString callback:(_Nonnull SearchResultCompletionFuncCallback) callback NS_SWIFT_NAME(getSearchResult(searchString:callback:));
- (NSArray<CHSpace *> * _Nonnull)getCallHistory;
- (NSString * _Nullable)dial:(NSString * _Nonnull)input NS_SWIFT_NAME(dial(input:));
- (NSString * _Nullable)dial:(NSString * _Nonnull)input localVideoView:(void * _Nullable)localVideoView remoteVideoView:(void * _Nullable)remoteVideoView sharingVideoView:(void * _Nullable)sharingVideoView NS_SWIFT_NAME(dial(input:localVideoView:remoteVideoView:sharingVideoView:));
- (void)startShare:(NSString * _Nonnull)callId NS_SWIFT_NAME(startShare(callId:));
- (void)stopShare:(NSString * _Nonnull)callId  NS_SWIFT_NAME(stopShare(callId:));
- (void)setupExternalInput:(NSString * _Nonnull)callId height:(NSNumber * _Nonnull)height width:(NSNumber * _Nonnull)width NS_SWIFT_NAME(setupExternalInput(callId:height:width:));
- (void)sendFrameToExternalInputter:(NSString * _Nonnull)callId timeStamp:(NSNumber * _Nonnull)timeStamp height:(NSNumber * _Nonnull)height width:(NSNumber * _Nonnull)width data:(void * const _Nonnull)data length:(NSNumber * _Nonnull)length NS_SWIFT_NAME(sendFrameToExternalInputter(callId:timeStamp:height:width:data:length:));
- (void)answer:(NSString * _Nonnull)callId localVideoView:(void * _Nullable)localVideoView remoteVideoView:(void * _Nullable)remoteVideoView sharingVideoView:(void * _Nullable)sharingVideoView callback:(_Nullable CallStartedCompletionCallback) callback NS_SWIFT_NAME(answer(callId:localVideoView:remoteVideoView:sharingVideoView:callback:));
- (NSArray<CHMeetingInfo *> * _Nullable)getSchedules:(NSString * _Nonnull)callId NS_SWIFT_NAME(getSchedules(callId:));
- (void)joinCall:(NSString * _Nonnull)callId isAudioOnly:(bool)isAudioOnly callback:(_Nullable CallStartedCompletionCallback) callback NS_SWIFT_NAME(joinCall(callId:isAudioOnly:callback:));
- (void)declineCall:(NSString * _Nonnull)callId NS_SWIFT_NAME(declineCall(callId:));
- (void)endCall:(NSString * _Nonnull)callId NS_SWIFT_NAME(endCall(callId:));
- (void)endActiveCall;
- (void)muteAudio:(NSString * _Nonnull)callId participantId:(NSString * _Nonnull)participantId isMuted:(bool)isMuted NS_SWIFT_NAME(muteAudio(callId:participantId:isMuted:));
- (void)muteAll:(NSString * _Nonnull)callId doMute:(bool)doMute NS_SWIFT_NAME(muteAll(callId:doMute:));
- (bool)isOnHold:(NSString * _Nonnull)callId NS_SWIFT_NAME(isOnHold(callId:));
- (void)holdCall:(NSString * _Nonnull)callId isMuted:(bool)onHold NS_SWIFT_NAME(holdCall(callId:onHold:));
- (void)startAssociatedCall:(NSString * _Nonnull)callId dialNumber:(NSString * _Nonnull)dialNumber associationType:(enum CHCallAssociationType)associationType audioCall:(bool)audioCall callback:(_Nullable CallStartedCompletionCallback) callback NS_SWIFT_NAME(startAssociatedCall(callId:dialNumber:associationType:audioCall:callback:));
- (void)transferCall:(NSString * _Nonnull)fromCallId toCallId:(NSString * _Nonnull)toCallId NS_SWIFT_NAME(transferCall(fromCallId:toCallId:));
- (void)mergeCall:(NSString * _Nonnull)callId targetCallId:(NSString * _Nonnull)targetCallId NS_SWIFT_NAME(mergeCall(callId:targetCallId:));
- (void)swapCamera:(NSString * _Nonnull)callId NS_SWIFT_NAME(swapCamera(callId:));
- (NSArray<CHCallMembership *> * _Nonnull)getCallMemberships:(NSString * _Nonnull)callId NS_SWIFT_NAME(getCallMemberships(callId:));
- (NSString * _Nonnull)getCallIdByNotificationId:(NSString * _Nonnull)notificationId notificationType:(enum CHNotificationCallType)notificationType NS_SWIFT_NAME(getCallIdByNotificationId(notificationId:notificationType:));
- (CHCall * _Nullable)getCall:(NSString * _Nonnull)callId NS_SWIFT_NAME(getCall(callId:));
- (void)setVideoMaxTxFPS:(NSNumber * _Nonnull)fps NS_SWIFT_NAME(setVideoMaxTxFPS(fps:));
- (void)setVideoEnableDecoderMosaic:(bool)value NS_SWIFT_NAME(setVideoEnableDecoderMosaic(value:));
- (NSString * _Nonnull)getWmeVersion NS_SWIFT_NAME(getWmeVersion());
- (void)sendFeedback:(NSNumber * _Nonnull)rating comments:(NSString * _Nonnull) comments NS_SWIFT_NAME(sendFeedback(rating:comments:));
- (NSString * _Nonnull)sendDTMF:(NSString * _Nonnull)callId keys:(NSString * _Nonnull) keys NS_SWIFT_NAME(sendDTMF(callId:keys:));
- (void)enableBNR:(NSString * _Nonnull)callId enable:(bool)enable NS_SWIFT_NAME(enableBNR(callId:enable:));
- (bool)isBNREnabled:(NSString * _Nonnull)callId NS_SWIFT_NAME(isBNREnabled(callId:));
- (bool)setBNRProfileMode:(NSString * _Nonnull)callId mode:(NSNumber * _Nonnull)mode NS_SWIFT_NAME(setBNRProfileMode(callId:mode:));
- (NSNumber * _Nonnull)getBNRProfileMode:(NSString * _Nonnull)callId NS_SWIFT_NAME(getBNRProfileMode(callId:));
- (void)setVideoMaxRxBandwidth:(NSNumber * _Nonnull)bandwidth NS_SWIFT_NAME(setVideoMaxRxBandwidth(bandwidth:));
- (void)setVideoMaxTxBandwidth:(NSNumber * _Nonnull)bandwidth NS_SWIFT_NAME(setVideoMaxTxBandwidth(bandwidth:));
- (void)setSharingMaxRxBandwidth:(NSNumber * _Nonnull)bandwidth NS_SWIFT_NAME(setSharingMaxRxBandwidth(bandwidth:));
- (void)setAudioMaxRxBandwidth:(NSNumber * _Nonnull)bandwidth NS_SWIFT_NAME(setAudioMaxRxBandwidth(bandwidth:));
- (void)startPreview:(void * _Nonnull)viewHandle NS_SWIFT_NAME(startPreview(viewHandle:));
- (void)stopPreview NS_SWIFT_NAME(stopPreview());
- (void)setDefaultCameraMode:(NSNumber * _Nonnull)mode NS_SWIFT_NAME(setDefaultCameraMode(mode:));
- (void)setVideoRenderViews:(NSString * _Nonnull)callId localVideoView:(void * _Nullable)localVideoView remoteVideoView:(void * _Nullable)remoteVideoView NS_SWIFT_NAME(setVideoRenderViews(callId:localVideoView:remoteVideoView:));
- (void)setSharingRenderView:(NSString * _Nonnull)callId sharingVideoView:(void * _Nullable)sharingVideoView NS_SWIFT_NAME(setSharingRenderView(callId:sharingVideoView:));
- (void)setRemoteVideoRenderMode:(NSString * _Nonnull)callId mode:(CHVideoRenderMode)mode NS_SWIFT_NAME(setRemoteVideoRenderMode(callId:mode:));
- (void)setIncomingCallListener:(_Nonnull IncomingCompletionCallback) callback NS_SWIFT_NAME(setIncomingCallListener(callback:));
- (void)setDeviceChangedListener:(NSString * _Nonnull)callId callback:(_Nonnull DeviceChangedCompletionCallback) callback NS_SWIFT_NAME(setDeviceChangedListener(callId:callback:));
- (void)setSendingVideo:(NSString * _Nonnull)callId sending:(bool) sending NS_SWIFT_NAME(setSendingVideo(callId:sending:));
- (void)setSendingAudio:(NSString * _Nonnull)callId sending:(bool) sending NS_SWIFT_NAME(setSendingAudio(callId:sending:));
- (void)setSendingSharing:(NSString * _Nonnull)callId sending:(bool) sending sourceId:(NSString * _Nonnull)sourceId NS_SWIFT_NAME(setSendingSharing(callId:sending:sourceId:));
- (void)setReceivingVideo:(NSString * _Nonnull)callId receiving:(bool) receiving NS_SWIFT_NAME(setReceivingVideo(callId:receiving:));
- (void)setReceivingAudio:(NSString * _Nonnull)callId receiving:(bool) receiving NS_SWIFT_NAME(setReceivingAudio(callId:receiving:));
- (void)setReceivingSharing:(NSString * _Nonnull)callId receiving:(bool) receiving NS_SWIFT_NAME(setReceivingSharing(callId:receiving:));
- (void)onScheduleChanged:(NSString * _Nonnull)callId callback:(_Nonnull CallScheduleChangedCompletionCallback) callback NS_SWIFT_NAME(onScheduleChanged(callId:callback:));
- (void)setOnCallRingingChangedListener:(NSString * _Nonnull)callId callback:(_Nonnull CallRingingChangedCompletionCallback) callback NS_SWIFT_NAME(setOnCallRingingChangedListener(callId:callback:));
- (void)setOnCallConnectedListener:(NSString * _Nonnull)callId callback:(_Nonnull CallConnectedCompletionCallback) callback NS_SWIFT_NAME(setOnCallConnectedListener(callId:callback:));
- (void)setOnCallDisconnectedListener:(NSString * _Nonnull)callId callback:(_Nonnull CallDisconnectedCompletionCallback) callback NS_SWIFT_NAME(setOnCallDisconnectedListener(callId:callback:));
- (void)setOnCallTerminatedListener:(NSString * _Nonnull)callId callback:(_Nonnull CallTerminatedCompletionCallback) callback NS_SWIFT_NAME(setOnCallTerminatedListener(callId:callback:));
- (void)setOnCallFailedListener:(NSString * _Nonnull)callId callback:(_Nonnull CallFailedCompletionCallback) callback NS_SWIFT_NAME(setOnCallFailedListener(callId:callback:));
- (void)setOnCallInfoChangedListener:(NSString * _Nonnull)callId callback:(_Nonnull CallInfoChangedCompletionCallback) callback NS_SWIFT_NAME(setOnCallInfoChangedListener(callId:callback:));
// MARK: Persons
- (void)getMe:(PersonGetResultCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(getMe(completionHandler:));
- (void)getPersonWithId:(NSString * _Nonnull)personId completionHandler:(PersonGetResultCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(getPersonWithId(personId:completionHandler:));
- (void)listPersons:(NSString * _Nullable)email displayName:(NSString * _Nullable)displayName idString:(NSString* _Nullable)idString orgId:(NSString* _Nullable)orgId max:(NSNumber * _Nullable)max completionHandler:(ListPersonsCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(listPersons(email:displayName:idString:orgId:max:completionHandler:));
- (void)createPerson:(NSString * _Nonnull)email displayName:(NSString * _Nullable)displayName firstName:(NSString * _Nullable)firstName lastName:(NSString * _Nullable)lastName avatar:(NSString * _Nullable)avatar orgId:(NSString* _Nullable)orgId roles:(NSString* _Nullable)roles licenses:(NSString* _Nullable)licenses completionHandler:(CreatePersonCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(createPerson(email:displayName:firstName:lastName:avatar:orgId:roles:licenses:completionHandler:));
- (void)updatePerson:(NSString * _Nonnull)personId email:(NSString * _Nullable)email displayName:(NSString * _Nullable)displayName firstName:(NSString * _Nullable)firstName lastName:(NSString * _Nullable)lastName avatar:(NSString * _Nullable)avatar orgId:(NSString* _Nullable)orgId roles:(NSString* _Nullable)roles licenses:(NSString* _Nullable)licenses completionHandler:(UpdatePersonCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(updatePerson(personId:email:displayName:firstName:lastName:avatar:orgId:roles:licenses:completionHandler:));
- (void)deletePerson:(NSString * _Nonnull)personId completionHandler:(DeletePersonCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(deletePerson(personId:completionHandler:));


// MARK: Teams
- (NSArray<CHTeam *> * _Nonnull)listTeams:(NSNumber * _Nonnull)maxTeams NS_SWIFT_NAME(listTeams(maxTeams:));
- (void)createTeam:(NSString * _Nonnull)name completionHandler:(TeamCreateResultCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(createTeam(name:completionHandler:));
- (void)getTeamWithId:(NSString * _Nonnull)teamId completionHandler:(TeamGetResultCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(getTeamWithId(teamId:completionHandler:));
- (void)updateTeamWith:(NSString * _Nonnull)teamId newName:(NSString * _Nonnull)newName completionHandler:(TeamUpdateResultCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(updateTeamWith(teamId:newName:completionHandler:));
- (void)deleteTeamWithId:(NSString * _Nonnull)teamId completionHandler:(TeamArchiveResultCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(deleteTeamWithId(teamId:completionHandler:));

// MARK: Spaces
- (void)listSpaces:(NSString * _Nullable)teamId max:(NSNumber * _Nullable)max conversationType:(enum CHConversationType)conversationType sortType:(enum CHConversationSortType)sortType completionHandler:(ListSpacesCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(listSpaces(teamId:max:conversationType:sortType:completionHandler:));
- (void)getSpace:(NSString * _Nonnull)spaceId completionHandler:(SingleSpaceCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(getSpace(spaceId:completionHandler:));
- (void)createSpace:(NSString * _Nullable)teamId title:(NSString * _Nonnull)title completionHandler:(SingleSpaceCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(createSpace(teamId:title:completionHandler:));
- (void)updateSpaceTitle:(NSString * _Nonnull)spaceId newTitle:(NSString * _Nonnull)newTitle completionHandler:(UpdateSpaceTitleResultCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(updateSpaceTitle(spaceId:newTitle:completionHandler:));
- (void)deleteSpace:(NSString * _Nonnull)spaceId  completionHandler:(DeleteSpaceCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(deleteSpace(spaceId:completionHandler:));
- (void)getMeetingInfoFor:(NSString * _Nonnull)spaceId completionHandler:(void (^ _Nonnull)(CHSpaceMeetingInfo * _Nullable meetingInfo, BOOL success))completionHandler;
- (void)getReadStatus:(NSString * _Nonnull)spaceId completionHandler:(SingleSpaceReadStatucCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(getReadStatus(spaceId:completionHandler:));
- (void)listReadStatus:(NSNumber * _Nonnull)max completionHandler:(ListSpaceReadStatucCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(listReadStatus(max:completionHandler:));
- (void)setOnSpaceEventListener:(_Nullable SpaceEventCompletionCallback) callback NS_SWIFT_NAME(setOnSpaceEventListener(callback:));
- (void)setOnSpaceEventWithPayloadListener:(_Nullable SpaceEventWithPayloadCompletionCallback) callback NS_SWIFT_NAME(setOnSpaceEventWithPayloadListener(callback:));
- (void)listWithActiveCalls:(ListSpacesActiveCallsCompletionCallback _Nonnull)completionHandler NS_SWIFT_NAME(listWithActiveCalls(completionHandler:));

// MARK: Team Membership
- (void)listTeamMembershipIn:(NSString * _Nonnull)teamId max:(NSNumber * _Nullable)max completionHandler:(ListTeamMembershipCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(listTeamMembershipIn(teamId:max:completionHandler:));
- (void)createTeamMembershipWithPersonId:(NSString * _Nonnull)personId teamId:(NSString * _Nonnull)teamId isModerator:(bool)isModerator completionHandler:(CreateTeamMembershipCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(createTeamMembershipWith(personId:teamId:isModerator:completionHandler:));
- (void)createTeamMembershipWithEmailAddress:(NSString * _Nonnull)emailAddress teamId:(NSString * _Nonnull)teamId isModerator:(bool)isModerator completionHandler:(CreateTeamMembershipCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(createTeamMembershipWith(emailAddress:teamId:isModerator:completionHandler:));
- (void)getTeamMembership:(NSString * _Nonnull)teamMembershipId completionHandler:(GetTeamMembershipCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(getTeamMembership(teamMembershipId:completionHandler:));
- (void)updateTeamMembershipWith:(NSString * _Nonnull)teamMembershipId isModerator:(bool)isModerator completionHandler:(UpdateTeamMembershipCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(updateTeamMembershipWith(teamMembershipId:isModerator:completionHandler:));
- (void)deleteTeamMembershipWithId:(NSString * _Nonnull)teamMembershipId completionHandler:(DeleteTeamMembershipCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(deleteTeamMembershipWithId(teamMembershipId:completionHandler:));

// MARK: Space Membership
- (void)listMemberships:(NSString * _Nullable)spaceId personId:(NSString * _Nullable)personId email:(NSString * _Nullable)email max:(NSNumber * _Nullable)max completionHandler:(ListMembershipsCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(listMemberships(spaceId:personId:email:max:completionHandler:));
- (void)getMembership:(NSString * _Nonnull)membershipId completionHandler:(GetMembershipByMembershipIdCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(get(membershipId:completionHandler:));
- (void)updateMembershipWith:(NSString * _Nonnull)membershipId isModerator:(bool)isModerator completionHandler:(MembershipUpdateResultCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(updateMembershipWith(membershipId:isModerator:completionHandler:));
- (void)createMembershipWithPersonId:(NSString * _Nonnull)personId spaceId:(NSString * _Nonnull)spaceId isModerator:(bool)isModerator completionHandler:(CreateMembershipCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(createMembershipWith(personId:spaceId:isModerator:completionHandler:));
- (void)createMembershipWithEmailAddress:(NSString * _Nonnull)emailAddress spaceId:(NSString * _Nonnull)spaceId isModerator:(bool)isModerator completionHandler:(CreateMembershipCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(createMembershipWith(emailAddress:spaceId:isModerator:completionHandler:));
- (void)deleteMembershipWithId:(NSString * _Nonnull)membershipId completionHandler:(MembershipDeleteResultCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(deleteMembershipWithId(membershipId:completionHandler:));
- (void)listMembershipsWithReadStatus:(NSString * _Nonnull)spaceId completionHandler:(ListMembershipsReadStatusCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(listMembershipsWithReadStatus(spaceId:completionHandler:));
- (void)setOnMembershipEventListener:(_Nullable MembershipEventCompletionCallback) callback NS_SWIFT_NAME(setOnMembershipEventListener(callback:));
- (void)setOnMembershipEventWithPayloadListener:(_Nullable MembershipEventWithPayloadCompletionCallback) callback NS_SWIFT_NAME(setOnMembershipEventWithPayloadListener(callback:));

// MARK: Messages
- (void)listMessages:(NSString * _Nonnull)spaceId max:(NSNumber * _Nonnull)max beforeMessageId:(NSString * _Nullable)beforeMessageId beforeDate:(NSDate * _Nullable)beforeDate mentionedPeople:(NSArray<CHMention *>* _Nullable)mentionedPeople completionHandler:(ListMessagesCompletionFuncCallback _Nonnull)completionHandler;
- (void)markMessageRead:(NSString * _Nonnull)spaceId messageId:(NSString * _Nullable) messageId completionHandler:(MarkMessageResultCompletionFuncCallback _Nonnull)completionHandler;
- (void)getMessage:(NSString * _Nonnull)messageId completionHandler:(_Nonnull SingleMessageCompletionFuncCallback)completion NS_SWIFT_NAME(getMessage(messageId:completionHandler:));
- (void)deleteMessage:(NSString * _Nonnull)messageId completionHandler:(_Nonnull MessageDeleteResultCompletionFuncCallback)completion NS_SWIFT_NAME(deleteMessage(messageId:completionHandler:));
- (void)postMessage:(CHMessageText * _Nullable)messageText destination:(NSString * _Nonnull)destination parent:(NSString * _Nullable)parent mentions:(NSArray<CHMention *>* _Nonnull)mentions files:(NSArray<NSDictionary<CHLocalFile *,NSArray<NSData *> *>*>* _Nonnull)files completionHandler:(_Nonnull MessagePostCompletionFuncCallback)completionHandler NS_SWIFT_NAME(postMessage(messageText:destination:parent:mentions:files:completionHandler:));
- (void)editMessage:(CHMessageText * _Nullable)messageText spaceId:(NSString * _Nonnull)spaceId parent:(NSString * _Nonnull)parent mentions:(NSArray<CHMention *>* _Nonnull)mentions completionHandler:(_Nonnull MessagePostCompletionFuncCallback)completionHandler NS_SWIFT_NAME(editMessage(messageText:conversationId:parentId:mentions:completionHandler:));
- (void)downloadFile:(NSString * _Nonnull)spaceId messageId:(NSString * _Nonnull)messageId contentIndex:(NSNumber * _Nonnull)contentIndex downloadPath:(NSString * _Nonnull)downloadPath progressHandler:(_Nullable MessageDownloadFileProgressCompletionFuncCallback)progressHandler completionHandler:(MessageDownloadFileCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(downloadFile(spaceId:messageId:contentIndex:downloadPath:progressHandler:completionHandler:));
- (void)downloadThumbnail:(NSString * _Nonnull)spaceId messageId:(NSString * _Nonnull)messageId contentIndex:(NSNumber * _Nonnull)contentIndex completionHandler:(MessageThumbnailResultCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(downloadThumbnail(spaceId:messageId:contentIndex:completionHandler:));
- (void)setOnMessageEventListener:(_Nullable MessageEventCompletionCallback) callback NS_SWIFT_NAME(setOnMessageEventListener(callback:));
- (void)setOnMessageEventWithPayloadListener:(_Nullable MessageEventWithPayloadCompletionCallback) callback NS_SWIFT_NAME(setOnMessageEventWithPayloadListener(callback:));

// MARK: Webhooks
- (void)listWebhooksWithMax:(NSNumber * _Nullable)max completionHandler:(ListWebhooksCompletionFuncCallback _Nonnull)completionHandler  NS_SWIFT_NAME(listWebhooks(max:completionHandler:));
- (void)getWebhook:(NSString * _Nonnull)webhookId completionHandler:(GetWebhookCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(getWebhook(webhookId:completionHandler:));
- (void)createWebhook:(NSString * _Nonnull)name targetUrl:(NSString * _Nonnull)targetUrl resource:(NSString * _Nonnull)resource event:(NSString * _Nonnull)event filter:(NSString * _Nullable)filter secret:(NSString * _Nullable)secret  completionHandler:(CreateWebhookCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(createWebhook(name:targetUrl:resource:event:filter:secret:completionHandler:));
- (void)updateWebhook:(NSString * _Nonnull)webhookId name:(NSString * _Nonnull)name targetUrl:(NSString * _Nonnull)targetUrl secret:(NSString * _Nullable)secret status:(NSString * _Nullable)status completionHandler:(UpdateWebhookCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(updateWebhook(webhookId:name:targetUrl:secret:status:completionHandler:));
- (void)deleteWebhook:(NSString * _Nonnull)webhookId completionHandler:(DeleteWebhookCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(deleteWebhook(webhookId:completionHandler:));

- (NSDictionary<NSString *, NSURL *>* _Nonnull)getLogFileUrls NS_SWIFT_NAME(getLogFileUrls());
- (void)base64EncodeResource:(enum CHResourceType)resourceType resource:(NSString * _Nonnull)resource completionHandler:(GetEncodedCompletionFuncCallback _Nonnull)completionHandler NS_SWIFT_NAME(base64EncodeResource(resourceType:resource:completionHandler:));
- (CHResource * _Nonnull)base64DecodeResource:(NSString * _Nonnull)encodedResource NS_SWIFT_NAME(base64DecodeResource(encodedResource:));
@end
